## MmGdbusModem3gppUssd MmGdbusModem3gppUssd — Generated C code for the org.freedesktop.ModemManager1.Modem.Modem3gpp.Ussd D-Bus interface |

## Functions

guint | mm_gdbus_modem3gpp_ussd_get_state ()
const gchar * | mm_gdbus_modem3gpp_ussd_get_network_request ()
gchar * | mm_gdbus_modem3gpp_ussd_dup_network_request ()
const gchar * | mm_gdbus_modem3gpp_ussd_get_network_notification ()
gchar * | mm_gdbus_modem3gpp_ussd_dup_network_notification ()
void | mm_gdbus_modem3gpp_ussd_call_initiate ()
gboolean | mm_gdbus_modem3gpp_ussd_call_initiate_finish ()
gboolean | mm_gdbus_modem3gpp_ussd_call_initiate_sync ()
void | mm_gdbus_modem3gpp_ussd_call_respond ()
gboolean | mm_gdbus_modem3gpp_ussd_call_respond_finish ()
gboolean | mm_gdbus_modem3gpp_ussd_call_respond_sync ()
void | mm_gdbus_modem3gpp_ussd_call_cancel ()
gboolean | mm_gdbus_modem3gpp_ussd_call_cancel_finish ()
gboolean | mm_gdbus_modem3gpp_ussd_call_cancel_sync ()

## Properties

char * | network-notification | Read / Write
char * | network-request | Read / Write
guint | state | Read / Write

## Signals

gboolean | handle-cancel | Run Last
gboolean | handle-initiate | Run Last
gboolean | handle-respond | Run Last

## Types and Values

| MmGdbusModem3gppUssd
struct | MmGdbusModem3gppUssdIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusModem3gppUssd

## Prerequisites

MmGdbusModem3gppUssd requires GObject.

## Known Implementations

MmGdbusModem3gppUssd is implemented by MMModem3gppUssd, MmGdbusModem3gppUssdProxy and MmGdbusModem3gppUssdSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Modem.Modem3gpp.Ussd D-Bus interface in C.

## Functions

### mm_gdbus_modem3gpp_ussd_get_state ()

    guint
    mm_gdbus_modem3gpp_ussd_get_state (MmGdbusModem3gppUssd *object);

Gets the value of the "State" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModem3gppUssd. |

#### Returns

The property value.

### mm_gdbus_modem3gpp_ussd_get_network_request ()

    const gchar *
    mm_gdbus_modem3gpp_ussd_get_network_request
                                   (MmGdbusModem3gppUssd *object);

Gets the value of the "NetworkRequest" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem3gpp_ussd_dup_network_request()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModem3gppUssd. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem3gpp_ussd_dup_network_request ()

    gchar *
    mm_gdbus_modem3gpp_ussd_dup_network_request
                                   (MmGdbusModem3gppUssd *object);

Gets a copy of the "NetworkRequest" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModem3gppUssd. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_modem3gpp_ussd_get_network_notification ()

    const gchar *
    mm_gdbus_modem3gpp_ussd_get_network_notification
                                   (MmGdbusModem3gppUssd *object);

Gets the value of the "NetworkNotification" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem3gpp_ussd_dup_network_notification()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModem3gppUssd. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem3gpp_ussd_dup_network_notification ()

    gchar *
    mm_gdbus_modem3gpp_ussd_dup_network_notification
                                   (MmGdbusModem3gppUssd *object);

Gets a copy of the "NetworkNotification" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModem3gppUssd. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_modem3gpp_ussd_call_initiate ()

    void
    mm_gdbus_modem3gpp_ussd_call_initiate (MmGdbusModem3gppUssd *proxy,
                                           const gchar *arg_command,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

Asynchronously invokes the `Initiate()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem3gpp_ussd_call_initiate_finish()` to get the result of the operation.

See `mm_gdbus_modem3gpp_ussd_call_initiate_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
arg_command | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem3gpp_ussd_call_initiate_finish ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_initiate_finish
                                   (MmGdbusModem3gppUssd *proxy,
                                    gchar **out_reply,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem3gpp_ussd_call_initiate()`.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
out_reply | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem3gpp_ussd_call_initiate()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem3gpp_ussd_call_initiate_sync ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_initiate_sync
                                   (MmGdbusModem3gppUssd *proxy,
                                    const gchar *arg_command,
                                    gchar **out_reply,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Initiate()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem3gpp_ussd_call_initiate()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
arg_command | Argument to pass with the method invocation. |
out_reply | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem3gpp_ussd_call_respond ()

    void
    mm_gdbus_modem3gpp_ussd_call_respond (MmGdbusModem3gppUssd *proxy,
                                          const gchar *arg_response,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `Respond()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem3gpp_ussd_call_respond_finish()` to get the result of the operation.

See `mm_gdbus_modem3gpp_ussd_call_respond_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
arg_response | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem3gpp_ussd_call_respond_finish ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_respond_finish
                                   (MmGdbusModem3gppUssd *proxy,
                                    gchar **out_reply,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem3gpp_ussd_call_respond()`.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
out_reply | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem3gpp_ussd_call_respond()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem3gpp_ussd_call_respond_sync ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_respond_sync
                                   (MmGdbusModem3gppUssd *proxy,
                                    const gchar *arg_response,
                                    gchar **out_reply,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Respond()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem3gpp_ussd_call_respond()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
arg_response | Argument to pass with the method invocation. |
out_reply | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem3gpp_ussd_call_cancel ()

    void
    mm_gdbus_modem3gpp_ussd_call_cancel (MmGdbusModem3gppUssd *proxy,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);

Asynchronously invokes the `Cancel()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem3gpp_ussd_call_cancel_finish()` to get the result of the operation.

See `mm_gdbus_modem3gpp_ussd_call_cancel_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem3gpp_ussd_call_cancel_finish ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_cancel_finish
                                   (MmGdbusModem3gppUssd *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem3gpp_ussd_call_cancel()`.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem3gpp_ussd_call_cancel()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem3gpp_ussd_call_cancel_sync ()

    gboolean
    mm_gdbus_modem3gpp_ussd_call_cancel_sync
                                   (MmGdbusModem3gppUssd *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Cancel()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem3gpp_ussd_call_cancel()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModem3gppUssdProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusModem3gppUssd

    typedef struct _MmGdbusModem3gppUssd MmGdbusModem3gppUssd;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Modem.Modem3gpp.Ussd.

### struct MmGdbusModem3gppUssdIface

    struct MmGdbusModem3gppUssdIface {
      GTypeInterface parent_iface;

      gboolean (*handle_cancel) (
        MmGdbusModem3gppUssd *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_initiate) (
        MmGdbusModem3gppUssd *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_command);

      gboolean (*handle_respond) (
        MmGdbusModem3gppUssd *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_response);

      const gchar * (*get_network_notification) (MmGdbusModem3gppUssd *object);

      const gchar * (*get_network_request) (MmGdbusModem3gppUssd *object);

      guint  (*get_state) (MmGdbusModem3gppUssd *object);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Modem.Modem3gpp.Ussd.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_cancel` () | Handler for the “handle-cancel” signal. |
`handle_initiate` () | Handler for the “handle-initiate” signal. |
`handle_respond` () | Handler for the “handle-respond” signal. |
`get_network_notification` () | Getter for the “network-notification” property. |
`get_network_request` () | Getter for the “network-request” property. |
`get_state` () | Getter for the “state” property. |

## Property Details

### The `“network-notification”` property

      “network-notification”     char *

Represents the D-Bus property "NetworkNotification".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModem3gppUssd

Flags: Read / Write

Default value: NULL

### The `“network-request”` property

      “network-request”          char *

Represents the D-Bus property "NetworkRequest".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModem3gppUssd

Flags: Read / Write

Default value: NULL

### The `“state”` property

      “state”                    guint

Represents the D-Bus property "State".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModem3gppUssd

Flags: Read / Write

Default value: 0

## Signal Details

### The `“handle-cancel”` signal

    gboolean
    user_function (MmGdbusModem3gppUssd  *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Cancel()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem3gpp_ussd_complete_cancel()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModem3gppUssd. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-initiate”` signal

    gboolean
    user_function (MmGdbusModem3gppUssd  *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_command,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Initiate()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem3gpp_ussd_complete_initiate()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModem3gppUssd. |
invocation | A GDBusMethodInvocation. |
arg_command | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-respond”` signal

    gboolean
    user_function (MmGdbusModem3gppUssd  *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_response,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Respond()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem3gpp_ussd_complete_respond()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModem3gppUssd. |
invocation | A GDBusMethodInvocation. |
arg_response | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last